
from math import log

class S:
    def __init__(self, prob, prev, out):
        self.prob = prob
        self.prev = prev
        self.out = out

class HMM:
    def __init__(self, femit, ftrans):
        self._femit = femit
        self._ftrans = ftrans
        self._lexicon = { word for words in femit.values() for word in words }
    
    @property
    def states(self):
        return (state for state in self._femit if state not in ('START', 'END'))
    
    def P_emit(self, y, o):
        # self._femit[y][o] gives you the frequency of o tagged as y
        pass
    
    def P_trans(self, x, y):
        # self._ftrans[x][y] gives you the frequency of the bigram (y,x)
        pass
    
    def maxprob(self, D, state, obs):
        def prob(prev, pemit = self.P_emit(state, obs)):
            return D[prev].prob * self.P_trans(prev, state) * pemit
        prev = max(D, key=prob)
        return S(prob(prev), prev, obs)
    
    def decode(self, observations):
        V = [ { 'START': S(1.0, None, '') } ]
        
        for obs in observations:
            V.append({ state : self.maxprob(V[-1], state, obs) for state in self.states })
        
        last = self.maxprob(V[-1], 'END', '')
        
        state = last.prev
        path = []
        
        for D in reversed(V[1:]):
            path.append((D[state].out, state))
            state = D[state].prev
        
        return (last.prob, path[::-1])
